﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _885708_RadGridView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Text = Telerik.WinControls.VersionNumber.Number.ToString();

            GridViewTextBoxColumn textBoxColumn = new GridViewTextBoxColumn();
            textBoxColumn.Name = "TextBoxColumn";
            textBoxColumn.HeaderText = "Product Name";
            textBoxColumn.FieldName = "ProductName";
            textBoxColumn.MaxLength = 50;
            textBoxColumn.TextAlignment = ContentAlignment.BottomRight;
            radGridView1.MasterTemplate.Columns.Add(textBoxColumn);

            GridViewMultiComboBoxColumn col = new GridViewMultiComboBoxColumn();
            col.Width = 200;
            col.DataSource = GetDummyData();
            col.DisplayMember = "Drink";
            col.ValueMember = "DrinkID";
            col.FieldName = "Drink";
            col.HeaderText = "Drink";
            this.radGridView1.Columns.Add(col);
            this.radGridView1.CellBeginEdit += new GridViewCellCancelEventHandler(radGridView1_CellBeginEdit);

            for (int i = 0; i < 10; i++)
            {
                if (i % 2 == 0)
                {
                    this.radGridView1.Rows.Add("Test " + i, 0);
                }
                else if (i % 3 == 0)
                {
                    this.radGridView1.Rows.Add("Test " + i, 5);
                }
                else if (i % 5 == 0)
                {
                    this.radGridView1.Rows.Add("Test " + i, 8);
                }
            }

            this.radGridView1.CellEditorInitialized += radGridView1_CellEditorInitialized;
        }

        void radGridView1_CellEditorInitialized(object sender, GridViewCellEventArgs e)
        {
            RadMultiColumnComboBoxElement element = e.ActiveEditor as RadMultiColumnComboBoxElement;
            if (element != null)
            {
                element.EditorControl.Columns["DrinkID"].IsVisible = false;
                element.EditorControl.ViewCellFormatting += EditorControl_ViewCellFormatting;
            }
        }

        void EditorControl_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.CellElement is GridRowHeaderCellElement && e.RowIndex != -1)
            {
                e.CellElement.Text = e.CellElement.RowIndex.ToString();
            }
            else if (e.CellElement is GridHeaderCellElement)
            {
                e.Column.HeaderText = String.Format("{0}.{1}", e.ColumnIndex, e.Column.Name);
            }
            else
            {
                e.CellElement.ResetValue(LightVisualElement.TextProperty, Telerik.WinControls.ValueResetFlags.Local);
            }
        }

        bool isColumnAdded;

        void radGridView1_CellBeginEdit(object sender, GridViewCellCancelEventArgs e)
        {
            if (this.radGridView1.CurrentColumn is GridViewMultiComboBoxColumn)
            {
                if (!isColumnAdded)
                {
                    isColumnAdded = true;
                    RadMultiColumnComboBoxElement editor = (RadMultiColumnComboBoxElement)this.radGridView1.ActiveEditor;
                    editor.AutoSizeDropDownToBestFit = true;
                }
            }
        }

        public DataTable GetDummyData()
        {
            string[] coffeeDrinks =
            {
                "Americano",
                "Cafe Crema",
                "Caffe Latte",
                "Caffe macchiato",
                "Coffee milk",
                "Cafe mocha",
                "Irish coffee",
                "Espresso",
                "espresso long",
                "Cuban espresso",
                "Frappuccino",
                "Greek frappe coffee",
                "Indian filter coffee",
                "Iced Coffee ",
                "Cafe mélange"
            };

            DataTable tableDrinks = new DataTable();
            tableDrinks.Columns.Add("DrinkID", typeof(int));
            tableDrinks.Columns.Add("Drink", typeof(string));
            tableDrinks.Columns.Add("State", typeof(bool));

            for (int i = 0; i < coffeeDrinks.Length; i++)
            {
                if (i % 2 == 0)
                {
                    tableDrinks.Rows.Add(i, coffeeDrinks[i], true);
                }
                else
                {
                    tableDrinks.Rows.Add(i, coffeeDrinks[i], false);
                }
            }

            return tableDrinks;
        }
    }
}
